



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>uva10245-The Closest Pair Problem(平面上的点分治)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">uva10245-The Closest Pair Problem(平面上的点分治)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 10:18:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>解析：平面上的点分治，先递归得到左右子区间的最小值d，<br />再处理改区间，肯定不会考虑哪些距离已经大于d的点对，<br />对y坐标归并排序，然后从小到大开始枚举更新d，对于某个点，<br />x轴方向只用考虑[x-d,x+d](x是分的中轴线)，y轴方向只用考虑<br />[y-d,y](y是这个点的y值),因为d值一直在变小，所以这个矩形包<br />含的点数很少。</p>
<p>代码</p>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;string&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;algorithm&gt;<br />
using namespace std;<br />
const double INF=1e9;<br />
const int maxn=;<br />
int N;<br />
struct Po<br />
{<br />
    double x,y;<br />
    Po(double x=,double y=):x(x),y(y){}<br />
}po[maxn],B[maxn];<br />
bool cmp(const Po&amp; a,const Po&amp; b)<br />
{<br />
    if(a.x!=b.x) return a.x&lt;b.x;<br />
    return a.y&lt;b.y;<br />
}<br />
double dfs(int l,int r)<br />
{<br />
    if(l&gt;=r) return INF;<br />
    int mid=(l+r)/;<br />
    double x=po[mid].x;<br />
    double d=min(dfs(l,mid),dfs(mid+,r)); //先处理左右子区间<br />
    int ls=l,rs=mid+,k=l;<br />
    while(ls&lt;=mid&amp;&amp;rs&lt;=r) //归并排序<br />
    {<br />
        if(po[ls].y&lt;=po[rs].y) B[k++]=po[ls++];<br />
        else B[k++]=po[rs++];<br />
    }<br />
    while(ls&lt;=mid) B[k++]=po[ls++];<br />
    while(rs&lt;=r) B[k++]=po[rs++];<br />
    for(int i=l;i&lt;=r;i++) po[i]=B[i];<br />
    int Size=;<br />
    for(int i=l;i&lt;=r;i++)<br />
    {<br />
        if(fabs(po[i].x-x)&gt;=d) continue; //不考虑<br />
        for(int j=Size;j&gt;=;j--)<br />
        {<br />
            double a=po[i].x-B[j].x;<br />
            double b=po[i].y-B[j].y;<br />
            if(b&gt;=d) break;<br />
            d=min(d,sqrt(a*a+b*b));  //更新<br />
        }<br />
        B[++Size]=po[i];<br />
    }<br />
    return d;<br />
}<br />
int main()<br />
{<br />
    while(scanf("%d",&amp;N)!=EOF&amp;&amp;N)<br />
    {<br />
        double x,y;<br />
        for(int i=;i&lt;=N;i++)<br />
        {<br />
            scanf("%lf%lf",&amp;x,&amp;y);<br />
            po[i]=Po(x,y);<br />
        }<br />
        sort(po+,po+N+,cmp);<br />
        double ans=dfs(,N);<br />
        if(ans&lt;) printf("%.4f\n",ans);<br />
        else printf("INFINITY\n");<br />
    }<br />
    return ;<br />
}</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93yek08.html">sql 存储过程 output参数的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdzwn79.html">SPM Homework 1 &mdash;A Project From My Personal Life</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rmj3r8.html">mysql 插入&sol;更新数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mv7po8.html">1&period;把二元查找树转变成排序的双向链表&lbrack;BST2DoubleLinkedList&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j6jjlq.html">VS中新建类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yonk5q.html">【动态规划】XMU 1560 新ACM规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m62gxq.html">java&lowbar;IO流之 NIO</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok7ee59.html">poj3090--欧拉函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljlox19.html">XShell删除键之类的不正常</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zordxvq.html">使用JAVA开发微信公众平台（一）&mdash;&mdash;环境搭建与开发接入</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gedpz08.html">【转】Java中关于异常处理的十个最佳实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpv3359.html">BigDecimal四舍五入使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd773z9.html">201521123107 《Java程序设计》第7周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zjoo19.html">Python的用户交互程序及格式化输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxd2vq.html">开源Android-PullToRefresh下拉刷新源代码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j11g0l9.html">SpringMvc参数传递中乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rp6ym9.html">&lbrack;转&rsqb;decorators&period;xml的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3lwd9.html">fastjson java类、字符串、jsonObject之前的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy21gn9.html">忘记ios访问限制密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3dwkq.html">P2709 小B的询问（莫队）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qydzwvdq.html">windows puppet manifests 文件维护</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x2rze8.html">NSDate显示和时区的关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm6e6x9.html">php面向对象编程之构造方法&lowbar;&lowbar;construct&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1xpo39.html">Webservice-Java-Xfire</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdvgkm8.html">js练习【DOM操作】</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ovprj9.html">cocos2d移植到安卓引入第三方so文件时候编译会删除解决方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ylj1jq.html">&lbrack;Javascript&rsqb; Web APIs&colon; Persisting browser data with window&period;localStorage</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ov0139.html">Leetcode&lowbar;num3&lowbar;Same Tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z10kl39.html">edittext实现粘贴表情</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn72xj8.html">JavaScript深拷贝和浅拷贝</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
